# generated by datamodel-codegen:
#   filename:  https://api.nersc.gov/api/v1.2/openapi.json
#   timestamp: 2023-02-25T03:38:20+00:00

from __future__ import annotations

from datetime import date, datetime
from enum import Enum
from typing import Dict, List, Optional

from pydantic import BaseModel, Field


class BatchGroupAction(Enum):
    batch_add = "batch_add"
    batch_remove = "batch_remove"


class BodyCreateGroupAccountGroupsPost(BaseModel):
    name: str = Field(..., title="Name")
    repo_name: str = Field(..., title="Repo Name")


class BodyRunCommandUtilitiesCommandMachinePost(BaseModel):
    executable: str = Field(..., title="Executable")


class BodyStartTransferStorageTransferPost(BaseModel):
    source: str = Field(..., title="Source")
    target: str = Field(..., title="Target")
    outdir: str = Field(..., title="Outdir")
    infiles: str = Field(..., title="Infiles")
    username: Optional[str] = Field(None, title="Username")


class BodySubmitJobComputeJobsMachinePost(BaseModel):
    isPath: bool = Field(..., title="Ispath")
    job: str = Field(..., title="Job")


class BodyUpdateGroupMembershipAccountGroupsGroupPut(BaseModel):
    usernames: str = Field(..., title="Usernames")
    action: BatchGroupAction


class BodyUploadFileUtilitiesUploadMachinePathPut(BaseModel):
    file: bytes = Field(..., title="File")


class Changelog(BaseModel):
    date: Optional[date] = Field(None, title="Date")
    change: Optional[str] = Field(None, title="Change")


class Config(BaseModel):
    key: str = Field(..., title="Key")
    value: Optional[str] = Field(None, title="Value")


class DirectoryEntry(BaseModel):
    perms: Optional[str] = Field(None, title="Perms")
    hardlinks: Optional[int] = Field(0, title="Hardlinks")
    user: Optional[str] = Field(None, title="User")
    group: Optional[str] = Field(None, title="Group")
    size: Optional[float] = Field(0, title="Size")
    date: Optional[str] = Field(None, title="Date")
    name: Optional[str] = Field(None, title="Name")


class Note(BaseModel):
    name: str = Field(..., title="Name")
    notes: Optional[str] = Field(None, title="Notes")
    active: Optional[bool] = Field(False, title="Active")
    timestamp: Optional[datetime] = Field(None, title="Timestamp")


class Outage(BaseModel):
    name: str = Field(..., title="Name")
    start_at: Optional[datetime] = Field(None, title="Start At")
    end_at: Optional[datetime] = Field(None, title="End At")
    description: Optional[str] = Field(None, title="Description")
    notes: Optional[str] = Field(None, title="Notes")
    status: Optional[str] = Field(None, title="Status")
    swo: Optional[str] = Field(None, title="Swo")
    update_at: Optional[datetime] = Field(None, title="Update At")


class PublicHost(Enum):
    cori = "cori"
    dtn01 = "dtn01"
    perlmutter = "perlmutter"


class StatusValue(Enum):
    active = "active"
    unavailable = "unavailable"
    degraded = "degraded"
    other = "other"


class StorageStats(BaseModel):
    name: str = Field(..., title="Name")
    bytes_given: Optional[float] = Field(None, title="Bytes Given")
    bytes_used: Optional[float] = Field(None, title="Bytes Used")
    bytes_given_human: Optional[str] = Field(None, title="Bytes Given Human")
    bytes_used_human: Optional[str] = Field(None, title="Bytes Used Human")
    files_given: Optional[float] = Field(None, title="Files Given")
    files_used: Optional[float] = Field(None, title="Files Used")


class Task(BaseModel):
    id: str = Field(..., title="Id")
    uuid: Optional[str] = Field(None, title="Uuid")
    status: Optional[str] = Field(None, title="Status")
    result: Optional[str] = Field(None, title="Result")


class Tasks(BaseModel):
    tasks: Optional[List[Task]] = Field(None, title="Tasks")


class UserInfo(BaseModel):
    uid: int = Field(..., title="Uid")
    name: str = Field(..., title="Name")
    firstname: str = Field(..., title="Firstname")
    lastname: str = Field(..., title="Lastname")
    middlename: str = Field(..., title="Middlename")
    workphone: str = Field(..., title="Workphone")
    otherPhones: str = Field(..., title="Otherphones")
    email: str = Field(..., title="Email")


class UserStats(BaseModel):
    uid: int = Field(..., title="Uid")
    name: str = Field(..., title="Name")


class ValidationError(BaseModel):
    loc: List[str] = Field(..., title="Location")
    msg: str = Field(..., title="Message")
    type: str = Field(..., title="Error Type")


class AppRoutersComputeModelsStatus(Enum):
    OK = "OK"
    ERROR = "ERROR"


class AppRoutersStatusModelsStatus(BaseModel):
    name: str = Field(..., title="Name")
    full_name: Optional[str] = Field(None, title="Full Name")
    description: Optional[str] = Field(None, title="Description")
    system_type: Optional[str] = Field(None, title="System Type")
    notes: Optional[List[str]] = Field(None, title="Notes")
    status: StatusValue
    updated_at: Optional[datetime] = Field(None, title="Updated At")


class AppRoutersStorageModelsStatus(Enum):
    OK = "OK"
    ERROR = "ERROR"


class AppRoutersUtilsModelsStatus(Enum):
    OK = "OK"
    ERROR = "ERROR"


class DirectoryOutput(BaseModel):
    status: AppRoutersUtilsModelsStatus
    entries: List[DirectoryEntry] = Field(..., title="Entries")
    error: Optional[str] = Field(None, title="Error")
    file: Optional[str] = Field(None, title="File")
    is_binary: Optional[bool] = Field(False, title="Is Binary")


class FileDownload(BaseModel):
    status: AppRoutersUtilsModelsStatus
    file: Optional[str] = Field(None, title="File")
    is_binary: Optional[bool] = Field(False, title="Is Binary")
    error: Optional[str] = Field(None, title="Error")


class GroupStats(BaseModel):
    gid: int = Field(..., title="Gid")
    name: str = Field(..., title="Name")
    users: Optional[List[UserStats]] = Field(None, title="Users")


class HTTPValidationError(BaseModel):
    detail: Optional[List[ValidationError]] = Field(None, title="Detail")


class JobOutput(BaseModel):
    status: AppRoutersComputeModelsStatus
    output: List[Dict[str, str]] = Field(..., title="Output")
    error: Optional[str] = Field(None, title="Error")


class ProjectStats(BaseModel):
    id: int = Field(..., title="Id")
    description: str = Field(..., title="Description")
    repo_name: str = Field(..., title="Repo Name")
    iris_role: Optional[str] = Field(None, title="Iris Role")
    hours_given: Optional[float] = Field(None, title="Hours Given")
    hours_used: Optional[float] = Field(None, title="Hours Used")
    project_hours_given: Optional[float] = Field(None, title="Project Hours Given")
    project_hours_used: Optional[float] = Field(None, title="Project Hours Used")
    projdir_usage: Optional[List[StorageStats]] = Field(None, title="Projdir Usage")
    project_projdir_usage: Optional[StorageStats] = None
    hpss_usage: Optional[List[StorageStats]] = Field(None, title="Hpss Usage")


class QueueOutput(BaseModel):
    status: AppRoutersComputeModelsStatus
    output: List[Dict[str, str]] = Field(..., title="Output")
    error: Optional[str] = Field(None, title="Error")


class TransferResult(BaseModel):
    task_id: str = Field(..., title="Task Id")
    status: AppRoutersStorageModelsStatus
    reason: Optional[str] = Field(None, title="Reason")


class UploadResult(BaseModel):
    status: AppRoutersUtilsModelsStatus
    output: Optional[str] = Field(None, title="Output")
    error: Optional[str] = Field(None, title="Error")


class AppRoutersComputeModelsCommandOutput(BaseModel):
    task_id: str = Field(..., title="Task Id")
    status: AppRoutersComputeModelsStatus
    error: Optional[str] = Field(None, title="Error")


class AppRoutersUtilsModelsCommandOutput(BaseModel):
    task_id: str = Field(..., title="Task Id")
    status: AppRoutersUtilsModelsStatus
    error: Optional[str] = Field(None, title="Error")


class GroupList(BaseModel):
    groups: Optional[List[GroupStats]] = Field(None, title="Groups")

# generated by datamodel-codegen:
#   filename:  Squeue.json
#   timestamp: 2023-02-25T03:38:20+00:00


from typing import Any, List, Optional

from pydantic import BaseModel, Field


class OutputItemSqueue(BaseModel):
    account: Optional[str] = None
    tres_per_node: Optional[str] = None
    min_cpus: Optional[str] = None
    min_tmp_disk: Optional[str] = None
    end_time: Optional[str] = None
    features: Optional[str] = None
    group: Optional[str] = None
    over_subscribe: Optional[str] = None
    jobid: Optional[str] = None
    name: Optional[str] = None
    comment: Optional[str] = None
    time_limit: Optional[str] = None
    min_memory: Optional[str] = None
    req_nodes: Optional[str] = None
    command: Optional[str] = None
    priority: Optional[str] = None
    qos: Optional[str] = None
    reason: Optional[str] = None
    field_: Optional[str] = None
    st: Optional[str] = None
    user: Optional[str] = None
    reservation: Optional[str] = None
    wckey: Optional[str] = None
    exc_nodes: Optional[str] = None
    nice: Optional[str] = None
    s_c_t: Optional[str] = Field(None, alias="s:c:t")
    exec_host: Optional[str] = None
    cpus: Optional[str] = None
    nodes: Optional[str] = None
    dependency: Optional[str] = None
    array_job_id: Optional[str] = None
    sockets_per_node: Optional[str] = None
    cores_per_socket: Optional[str] = None
    threads_per_core: Optional[str] = None
    array_task_id: Optional[str] = None
    time_left: Optional[str] = None
    time: Optional[str] = None
    nodelist: Optional[str] = None
    contiguous: Optional[str] = None
    partition: Optional[str] = None
    nodelist_reason_: Optional[str] = Field(None, alias="nodelist(reason)")
    start_time: Optional[str] = None
    state: Optional[str] = None
    uid: Optional[str] = None
    submit_time: Optional[str] = None
    licenses: Optional[str] = None
    core_spec: Optional[str] = None
    schednodes: Optional[str] = None
    work_dir: Optional[str] = None


class JobStatusResponseSqueue(BaseModel):
    status: Optional[str] = None
    output: Optional[List[OutputItemSqueue]] = None
    error: Optional[Any] = None

# generated by datamodel-codegen:
#   filename:  Sacct.json
#   timestamp: 2023-02-25T03:38:20+00:00


from typing import Any, List, Optional

from pydantic import BaseModel


class OutputItemSacct(BaseModel):
    account: Optional[str] = None
    admincomment: Optional[str] = None
    alloccpus: Optional[str] = None
    allocnodes: Optional[str] = None
    alloctres: Optional[str] = None
    associd: Optional[str] = None
    avecpu: Optional[str] = None
    avecpufreq: Optional[str] = None
    avediskread: Optional[str] = None
    avediskwrite: Optional[str] = None
    avepages: Optional[str] = None
    averss: Optional[str] = None
    avevmsize: Optional[str] = None
    blockid: Optional[str] = None
    cluster: Optional[str] = None
    comment: Optional[str] = None
    constraints: Optional[str] = None
    consumedenergy: Optional[str] = None
    consumedenergyraw: Optional[str] = None
    cputime: Optional[str] = None
    cputimeraw: Optional[str] = None
    dbindex: Optional[str] = None
    derivedexitcode: Optional[str] = None
    elapsed: Optional[str] = None
    elapsedraw: Optional[str] = None
    eligible: Optional[str] = None
    end: Optional[str] = None
    exitcode: Optional[str] = None
    flags: Optional[str] = None
    gid: Optional[str] = None
    group: Optional[str] = None
    jobid: Optional[str] = None
    jobidraw: Optional[str] = None
    jobname: Optional[str] = None
    layout: Optional[str] = None
    maxdiskread: Optional[str] = None
    maxdiskreadnode: Optional[str] = None
    maxdiskreadtask: Optional[str] = None
    maxdiskwrite: Optional[str] = None
    maxdiskwritenode: Optional[str] = None
    maxdiskwritetask: Optional[str] = None
    maxpages: Optional[str] = None
    maxpagesnode: Optional[str] = None
    maxpagestask: Optional[str] = None
    maxrss: Optional[str] = None
    maxrssnode: Optional[str] = None
    maxrsstask: Optional[str] = None
    maxvmsize: Optional[str] = None
    maxvmsizenode: Optional[str] = None
    maxvmsizetask: Optional[str] = None
    mcslabel: Optional[str] = None
    mincpu: Optional[str] = None
    mincpunode: Optional[str] = None
    mincputask: Optional[str] = None
    ncpus: Optional[str] = None
    nnodes: Optional[str] = None
    nodelist: Optional[str] = None
    ntasks: Optional[str] = None
    priority: Optional[str] = None
    partition: Optional[str] = None
    qos: Optional[str] = None
    qosraw: Optional[str] = None
    reason: Optional[str] = None
    reqcpufreq: Optional[str] = None
    reqcpufreqmin: Optional[str] = None
    reqcpufreqmax: Optional[str] = None
    reqcpufreqgov: Optional[str] = None
    reqcpus: Optional[str] = None
    reqmem: Optional[str] = None
    reqnodes: Optional[str] = None
    reqtres: Optional[str] = None
    reservation: Optional[str] = None
    reservationid: Optional[str] = None
    reserved: Optional[str] = None
    resvcpu: Optional[str] = None
    resvcpuraw: Optional[str] = None
    start: Optional[str] = None
    state: Optional[str] = None
    submit: Optional[str] = None
    suspended: Optional[str] = None
    systemcpu: Optional[str] = None
    systemcomment: Optional[str] = None
    timelimit: Optional[str] = None
    timelimitraw: Optional[str] = None
    totalcpu: Optional[str] = None
    tresusageinave: Optional[str] = None
    tresusageinmax: Optional[str] = None
    tresusageinmaxnode: Optional[str] = None
    tresusageinmaxtask: Optional[str] = None
    tresusageinmin: Optional[str] = None
    tresusageinminnode: Optional[str] = None
    tresusageinmintask: Optional[str] = None
    tresusageintot: Optional[str] = None
    tresusageoutave: Optional[str] = None
    tresusageoutmax: Optional[str] = None
    tresusageoutmaxnode: Optional[str] = None
    tresusageoutmaxtask: Optional[str] = None
    tresusageoutmin: Optional[str] = None
    tresusageoutminnode: Optional[str] = None
    tresusageoutmintask: Optional[str] = None
    tresusageouttot: Optional[str] = None
    uid: Optional[str] = None
    user: Optional[str] = None
    usercpu: Optional[str] = None
    wckey: Optional[str] = None
    wckeyid: Optional[str] = None
    workdir: Optional[str] = None


class JobStatusResponseSacct(BaseModel):
    status: Optional[str] = None
    output: Optional[List[OutputItemSacct]] = None
    error: Optional[Any] = None
